# -*- coding: utf-8 -*-
# Generated by Django 1.11.11 on 2018-09-12 13:02
from __future__ import unicode_literals

from django.db import migrations


def forwards_func(apps, schema_editor):
    # We get the model from the versioned app registry;
    # if we directly import it, it'll be the wrong version
    Chart = apps.get_model("hmi", "Chart")
    ProcessFlowDiagram = apps.get_model("hmi", "ProcessFlowDiagram")
    CustomHTMLPanel = apps.get_model("hmi", "CustomHTMLPanel")
    ControlPanel = apps.get_model("hmi", "ControlPanel")
    Widget = apps.get_model("hmi", "Widget")
    WidgetContent = apps.get_model("hmi", "WidgetContent")

    for c in Chart.objects.all():
        wc = WidgetContent(content_pk=c.pk,
                           content_model='pyscada.hmi.models.Chart')
        wc.save()

    for c in ProcessFlowDiagram.objects.all():
        wc = WidgetContent(content_pk=c.pk,
                           content_model='pyscada.hmi.models.ProcessFlowDiagram')
        wc.save()

    for c in CustomHTMLPanel.objects.all():
        wc = WidgetContent(content_pk=c.pk,
                           content_model='pyscada.hmi.models.CustomHTMLPanel')
        wc.save()

    for c in ControlPanel.objects.all():
        wc = WidgetContent(content_pk=c.pk,
                           content_model='pyscada.hmi.models.ControlPanel')
        wc.save()

    for w in Widget.objects.all():
        if w.chart is not None:
            content = WidgetContent.objects.filter(content_pk=w.chart.pk,
                                                   content_model='pyscada.hmi.models.Chart').first()
            if content is None:
                continue
        elif w.control_panel is not None:
            content = WidgetContent.objects.filter(content_pk=w.control_panel.pk,
                                                   content_model='pyscada.hmi.models.ControlPanel').first()
            if content is None:
                continue
        elif w.custom_html_panel is not None:
            content = WidgetContent.objects.filter(content_pk=w.custom_html_panel.pk,
                                                   content_model='pyscada.hmi.models.CustomHTMLPanel').first()
            if content is None:
                continue
        elif w.process_flow_diagram is not None:
            content = WidgetContent.objects.filter(content_pk=w.process_flow_diagram.pk,
                                                   content_model='pyscada.hmi.models.ProcessFlowDiagram').first()
            if content is None:
                continue
        else:
            continue
        w.content = content
        w.save()

class Migration(migrations.Migration):

    dependencies = [
        ('hmi', '0012_auto_20180912_1302'),
    ]

    operations = [
        migrations.RunPython(forwards_func),
            ]
